reconsult(File) :-
	retractall('$reconsult'(_, File)),
	seeing(Old),
	see(File),
	repeat,
	read(Clause),
	(
	    Clause == end_of_file
	;
	    (Clause = '?-'(Goals); Clause = ':-'(Goals)) ->
		
	    %% Execute goals directly, but don't let control fail back
	    %% through them.
	    (call(Goals) -> fail)
	;
	    reconsult_clause(Clause, File),
	    fail
	) ->
	retractall('$reconsult'(_, File)),
	seen,
	see(Old).

reconsult_clause(Clause, File) :-
	%% Get the head of the clause.
	(Clause = (Head :- _) -> true ; Head = Clause),

	%% Make sure we've cleared away previous instances of this
	%% predicate.
	(
	    \+ '$reconsult'(Head, File) ->
	    functor(Head, F, Arity),
	    functor(Template, F, Arity),
	    retractall(Template),
	    asserta('$reconsult'(Template, File))
	;
	    true
	),

	%% Now assert the clause.
	assertz(Clause).
